Package: shinyMatrix
Title: Shiny Matrix Input Field
Version: 0.8.1
Date: 2026-03-05
Authors@R: person(given = "Andreas",
                  family = "Neudecker",
                  role = c("aut", "cre"),
                  email = "andreas.neudecker@inwt-statistics.de")
Description: Implements a custom matrix input field. 
Depends: R (>= 3.5)
License: MIT + file LICENSE
Encoding: UTF-8
Imports: shiny, jsonlite
Suggests: testthat, covr
RoxygenNote: 7.3.2
URL: https://inwtlab.github.io/shinyMatrix/
NeedsCompilation: no
Packaged: 2026-03-05 15:54:31 UTC; ljabel
Author: Andreas Neudecker [aut, cre]
Maintainer: Andreas Neudecker <andreas.neudecker@inwt-statistics.de>
Repository: CRAN
Date/Publication: 2026-03-05 16:30:10 UTC
Built: R 4.6.0; ; 2026-04-26 12:13:57 UTC; unix

# Matrix Input for Shiny

[![R-CMD-check](https://github.com/INWTlab/shinyMatrix/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/INWTlab/shinyMatrix/actions/workflows/R-CMD-check.yaml)
[![Coverage Status](https://img.shields.io/codecov/c/github/INWTlab/shinyMatrix/master.svg)](https://app.codecov.io/github/INWTlab/shinyMatrix?branch=master)
[![CRAN status](https://www.r-pkg.org/badges/version/shinyMatrix)](https://cran.r-project.org/package=shinyMatrix)

# Matrix Input for Shiny

This package provides an input field to enter matrix conveniently in a shiny application. It supports tabbing and jumping linewise in the matrix.

![Screenshot Simple Matrix](https://github.com/INWTlab/shinyMatrix/raw/master/screenshot1.png)

## Installation
From CRAN:
```r
install.packages("shinyMatrix")
```
From GitHub:

```r
if (require("devtools")) install_github("INWTlab/shinyMatrix")
```

## Usage

### UI

The input field is generated by the function `matrixInput`

```r
matrixInput <- function(inputId,
                        value = matrix("", 1, 1),
                        inputClass = "",
                        rows = list(),
                        cols = list(),
                        class = "character"
                        pagination = FALSE,
                        lazy = FALSE){
  [...]
}
```
You can define parameters as follows:

| Parameter | Description |
|-|-|
| `inputId` | `id` of html element |
| `value` | matrix |
| `inputClass` | `class` of html element (Class `matrix-input` is added automatically) |
| `rows` | `list` of parameters (see below) |
| `cols` | `list` of parameters (see below) |
| `class` | class of resulting matrix (`numeric` and `character`) is supported |
| `pagination` | Should the matrix be paginated (10 rows per page) |
| `lazy` | Lazy update data on server |

Parameter `rows` / `cols` take a list of arguments. The following is supported

| Parameter | Description |
|-|-|
|`n`| number of rows (is calculated from `value` per default) |
|`names`| show row/colnames (names are taken from `value`)|
|`editableNames`| should row/colnames be editable? |
| `extend`| should rows/cols be automatically be added if table is filled to the last row / column? |
| `delta` | how many blank rows/cols should be added 
| `multiheader` | Display multiheader - currently only header spanning two columns are supported

Call the matrixInput function in your UI generating, e.g. ui.R

```r
## numeric matrix
matrixInput("matrix1", class = "numeric")

## editable rownames
matrixInput("matrix2",
  rows = list(
    names = TRUE,
    editableNames = TRUE),
  data = matrix(letters[1:12], 3, 4)
)
```
### Get value

You can access the value from the matrix input using `input$inputId` in your server function. The result will always be a matrix of the class defined in `matrixInput`.


### Update Input Field

You can update the input field using `updateMatrixInput`

```r
updateMatrixInput(session, inputId, value = NULL)
```

`value` is the data object. In the future there should be also support to update the other parameters.

## Example Apps

You find the code for the example app in `inst/appXXX`.

### Basic functionality

- Fixed matrix width
- Editable matrix content
- No column and rownames

Use the matrix on the left to input values, matrix on the right displays the result.

```r
library(shinyMatrix)

startApplication("app")
```

### Update Matrix Input from R

- Generate a random matrix within the shiny server function by clicking on "Update Matrix"
- The matrixInput field gets updated with `updateMatrixInput` from R

```r
startApplication("appUpdate")
```

### Editable row and column names

- Edit row and column names by clicking on the cell
- The result will be shown on the right

```r
startApplication("appRownames")
```

### Uneditable cells

- Make table cells uneditable
- No clicking into cells, no changing values

```r
startApplication("appUneditableCells")
```

### Extend Matrix Automatically

- If matrix is full (last row and columns contain values) rows and columns are added automatically 


```r
startApplication("appExtend")
```

### Custom Column Header

- Replace default header with a multiheader
- Automatically add 2 columns if matrix is full

```r
startApplication("appDoubleHeader")
```

### Delete Rows and Columns

- add a button to delete rows and columns. This also works for multiheader.

```r
startApplication("appDelete")
```

### Lazy Update of server values

- Only update data on server when no input field is visible

```r
startApplication("appLazy")
```

library(shinyMatrix)

m <- diag(5)
# colnames(m) <- 1:3
# rownames(m) <- letters[1:3]

shiny::tagList(
  shiny::fluidPage(
    shiny::titlePanel("Demonstration Matrix Input Field"),
    matrixInput(
      inputId = "matrix",
      value = m,
      class = "numeric",
      cols = list(
        names = TRUE,
        extend = TRUE,
        editableNames = TRUE,
        delta = 2,
        delete = TRUE
      ),
      rows = list(
        names = TRUE,
        extend = TRUE,
        editableNames = TRUE,
        delta = 1,
        delete = TRUE
      )
    )
  )
)

library(shinyMatrix)

m <- diag(5)
# colnames(m) <- 1:3
# rownames(m) <- letters[1:3]

shiny::tagList(
  shiny::fluidPage(
    shiny::titlePanel("Demonstration Matrix Input Field"),
    shiny::fluidRow(
      matrixInput(
        inputId = "matrix1",
        value = matrix(NA, 0, 0),
        class = "numeric",
        cols = list(
          names = TRUE
        ),
        rows = list(
          names = TRUE
        )
      ),
      matrixInput(
        inputId = "matrix2",
        value = {
          m <- matrix(NA, 3, 0)
          rownames(m) <- LETTERS[1:3]
          m
        },
        class = "numeric",
        cols = list(
          names = TRUE,
          extend = TRUE
        ),
        rows = list(
          names = TRUE,
          extend = FALSE
        )
      ),
      matrixInput(
        inputId = "matrix3",
        value = matrix(NA, 0, 0),
        class = "numeric",
        cols = list(
          names = TRUE,
          extend = TRUE
        ),
        rows = list(
          names = TRUE,
          extend = TRUE
        )
      )
    )
  )
)

library(shinyMatrix)

function(input, output, session) {
  output$table <- renderTable({
    req(colnames(input$matrix))
    input$matrix
  }, rownames = TRUE)

  observeEvent(input$button, {
    nrow <- sample(0:10, 1)
    ncol <- sample(0:10, 1)

    m <- matrix(round(rnorm(nrow * ncol), 2), nrow, ncol)

    colnames(m) <- sample(letters, ncol)
    rownames(m) <- paste(sample(LETTERS, nrow), seq_len(nrow))

    output$colnames <- renderText(paste(colnames(m), collapse = ", "))
    output$rownames <- renderText(paste(rownames(m), collapse = ", "))

    updateMatrixInput(session, "matrix", m)
  })
}

library(shinyMatrix)

function(input, output, session) {
  observe({
    cat(jsonlite::toJSON(input$matrix1))
  })

  observe({
    cat(jsonlite::toJSON(input$matrix2))
  })

  observe({
    cat(jsonlite::toJSON(input$matrix3))
  })
}

library(shinyMatrix)

m <- diag(6)
colnames(m) <- paste0(letters[1:6], "||", 1:2)
# rownames(m) <- letters[1:3]

shiny::tagList(
  shiny::fluidPage(
    shiny::titlePanel("Demonstration Matrix Input Field"),
    shiny::fluidRow(
      matrixInput(
        inputId = "matrix1",
        value = m,
        class = "numeric",
        cols = list(
          names = TRUE,
          editableNames = TRUE,
          multiheader = TRUE,
          extend = TRUE,
          delta = 2,
          delete = TRUE
        ),
        rows = list(
          names = TRUE,
          editableNames = TRUE,
          delete = TRUE
        )
      ),
    )
  )
)

library(shinyMatrix)

m <- diag(5)
# colnames(m) <- 1:5
# rownames(m) <- letters[1:5]

shiny::tagList(
  shiny::fluidPage(
    shiny::titlePanel("Demonstration Matrix Input Field"),
    shiny::fluidRow(
      column(6, matrixInput(
        inputId = "matrix",
        label = "Default matrix",
        value = m,
        class = "numeric",
        cols = list(
          names = TRUE
        ),
        rows = list(
          names = TRUE
        ),
        formatCell = ".2f"
      )),
      column(6, tableOutput("table"))
    )
  )
)

library(shinyMatrix)

m <- matrix(sample(letters, 16, replace = TRUE), 4, 4)
colnames(m) <- c("Var1||A", "Var1||B", "Var2||A", "Var2||B")

tagList(
  fluidPage(
    titlePanel("Custom Header"),
    tags$h3("Input"),
    matrixInput(
      inputId = "matrix",
      value = m,
      class = "character",
      pagination = TRUE,
      cols = list(
        names = TRUE,
        multiheader = TRUE,
        extend = TRUE,
        delta = 2,
        editableNames = TRUE
      ),
      rows = list(
        names = FALSE,
        extend = TRUE,
        delta = 1
      )
    )),
  tags$h3("Output"),
  fluidRow(
    column(6, tableOutput("table"))
  )
)
